/*
 * File: Screen_Select_RGB.c
 *
 * Created: Created: Friday August 2025 13:35:25
 *   Author: Chris
 */

// ============================================================================================
// Includes
#include "../Screens.h"
#include "../Command.h"
#include "../UI_Control.h"
#include "../Mode_Manager.h"
#include "../Command_Definition.h"

#include "../Display.h"
#include "../Display_Objects.h"
#include "../Display_Default_Configurations.h"


// ============================================================================================
// Variables
static Object_ID _Object_Message_Box;

static const Hierarchical_Menu* _Return_Menu = NULL;
static const Menu_List*         _Return_List = NULL;
static int32_t                  _Return_Selected_Item;

static char*        _Title;
static uint32_t     _Title_Length;
static LED_Data_t*  _RGB_Color;

static uint8_t      _Current_Component;
static uint8_t*     _Color;

static bool	        _Decision_Made;
static uint32_t	    _Counter;
static Mode	        _Current_Mode;


// ============================================================================================
// Function Declarations
void Screen_Setup_Select_RGB(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration, char* title, uint32_t title_length, LED_Data_t* rgb_color, const Hierarchical_Menu* return_menu, const Menu_List* return_list, int32_t return_selected_item);

static void Screen_Init                 (Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration);
static void Screen_Tick					(void);
static void Screen_Click				(uint button_return_value);
static void Screen_Touch_Event			(int16_t x, int16_t y);
static void Screen_Action_CW			(Object_ID object_id);
static void Screen_Action_CCW			(Object_ID object_id);
static void Screen_On_Object_Focused	(Object_ID object_id);
static void Screen_On_Object_Defocused	(Object_ID object_id);
static void Screen_On_Object_Select		(Object_ID object_id);
static void Screen_On_Object_Deselect	(Object_ID object_id);


/*******************************************************************
    Functions
*******************************************************************/
void Screen_Setup_Select_RGB(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration, char* title, uint32_t title_length, LED_Data_t* rgb_color, const Hierarchical_Menu* return_menu, const Menu_List* return_list, int32_t return_selected_item)
{
    _Current_Component = 0;
    _RGB_Color = rgb_color;
    _Color = &(rgb_color->Array[_Current_Component]);

    Screen_Init(direction_out, direction_in, type, frame_duration);

    _Return_Menu = return_menu;
    _Return_List = return_list;
    _Return_Selected_Item = return_selected_item;

    _Decision_Made = false;
    _Counter = 0;
    _Current_Mode = Mode_Manager_Get_Current_Mode();

    Mode_Manager_Set_Mode(PREVIEW);
}

void Screen_Init(Screen_Transition_Direction direction_out, Screen_Transition_Direction direction_in, Easing type, uint32_t frame_duration)
{
    _Screen_Tick                    = Screen_Tick;
    _Screen_Tick					= Screen_Tick;
	_Screen_Click					= Screen_Click;
	_Screen_Touch_Event				= Screen_Touch_Event;
	_Screen_Action_CW				= Screen_Action_CW;
	_Screen_Action_CCW				= Screen_Action_CCW;
	_Screen_On_Objects_Focused 		= Screen_On_Object_Focused;
	_Screen_On_Objects_Defocused 	= Screen_On_Object_Defocused;
	_Screen_On_Object_Select		= Screen_On_Object_Select;
	_Screen_On_Object_Deselect		= Screen_On_Object_Deselect;

	Display_Objects_Clear();
	Display_Screen_Transition_Start(direction_out, direction_in, type, frame_duration);


    //////////////////////////////
	// Add Display Objects here //
	//////////////////////////////
    Display_Objects_Add_Select_RGB(_RGB_Color, &_Current_Component, &_Configuration_Default_Select_RGB);  
    _Object_Message_Box = Display_Objects_Add_Message_Box(CENTER_MIDDLE, BOTH_IN_PERCENT, 50, 50, "Saved", MESSAGE_BOX_ICON_CIRCLE_CHECKMARK, &_Message_Box_Style_Regular);

    Display_Select_Object();

    UI_Control_Acceleration_Reset();
    UI_Control_Acceleration_Set_Enabled(true);
}

void Screen_Tick(void)
{
    Command_Issue_Set_Request(MULTICORE_COMMAND_SET_DIRECT_RED	, MULTICORE_NO_PARAMETER, _RGB_Color->R);
	Command_Issue_Set_Request(MULTICORE_COMMAND_SET_DIRECT_GREEN, MULTICORE_NO_PARAMETER, _RGB_Color->G);
	Command_Issue_Set_Request(MULTICORE_COMMAND_SET_DIRECT_BLUE	, MULTICORE_NO_PARAMETER, _RGB_Color->B);
    
    if(_Decision_Made) {
        _Counter++;
    }

    if(_Counter == MESSAGE_BOX_DEFAULT_TICKS) {
        Screen_Setup_Settings_Hierarchical_Menu(TRANSITION_DOWN, TRANSITION_RIGHT, SCREEN_TRANSITION_DEFAULT_EASING, SCREEN_TRANSITION_DEFAULT_FRAMES, _Return_Menu, _Return_List, _Return_Selected_Item);
    }
}

void Screen_Click(uint button_return_value)
{
	
}

void Screen_Touch_Event(int16_t x, int16_t y)
{

}

void Screen_Action_CW(Object_ID object_id)
{
    if(_Decision_Made) {
        return;
    }
    
    int32_t Color = *_Color;
    UI_Control_Selector_Inc(&Color, 0, UINT8_MAX, false);
    *_Color = (uint8_t)Color;
}

void Screen_Action_CCW(Object_ID object_id)
{
    if(_Decision_Made) {
        return;
    }
    
    int32_t Color = *_Color;
    UI_Control_Selector_Dec(&Color, 0, UINT8_MAX, false);
    *_Color = (uint8_t)Color;
}

void Screen_On_Object_Focused(Object_ID object_id)
{

}

void Screen_On_Object_Defocused(Object_ID object_id)
{
	
}

void Screen_On_Object_Select(Object_ID object_id)
{

}

void Screen_On_Object_Deselect(Object_ID object_id)
{
	if(_Current_Component < 2) {
        _Current_Component++;

        _Color = &(_RGB_Color->Array[_Current_Component]);

        Display_Select_Object();
        return;
    }
    
    if(!_Decision_Made) {
        Display_Objects_Show_Message_Box(_Object_Message_Box, MESSAGE_BOX_DEFAULT_TICKS);
        _Decision_Made = true;

        Command_Issue_Set_Request(MULTICORE_COMMAND_SET_DIRECT_RED	, MULTICORE_NO_PARAMETER, 0);
	    Command_Issue_Set_Request(MULTICORE_COMMAND_SET_DIRECT_GREEN, MULTICORE_NO_PARAMETER, 0);
	    Command_Issue_Set_Request(MULTICORE_COMMAND_SET_DIRECT_BLUE	, MULTICORE_NO_PARAMETER, 0);

        Mode_Manager_Set_Mode(_Current_Mode);
    }
}


/*******************************************************************
    Internal Functions
*******************************************************************/

